// tslint:disable
/**
 * Webitel engine API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 20.12.0
 * Contact: support@webitel.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as globalImportUrl from 'url';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, BaseAPI, RequiredError, } from '../base';
/**
 * QueueResourcesServiceApi - axios parameter creator
 * @export
 */
export const QueueResourcesServiceApiAxiosParamCreator = function (configuration) {
    return {
        /**
         *
         * @summary CreateQueueResourceGroup
         * @param {string} queueId
         * @param {EngineCreateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createQueueResourceGroup: async (queueId, body, options = {}) => {
            // verify required parameter 'queueId' is not null or undefined
            if (queueId === null || queueId === undefined) {
                throw new RequiredError('queueId', 'Required parameter queueId was null or undefined when calling createQueueResourceGroup.');
            }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling createQueueResourceGroup.');
            }
            const localVarPath = `/call_center/queues/{queue_id}/resource_groups`.replace(`{${'queue_id'}}`, encodeURIComponent(String(queueId)));
            const localVarUrlObj = globalImportUrl.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = {
                method: 'POST',
                ...baseOptions,
                ...options,
            };
            const localVarHeaderParameter = {};
            const localVarQueryParameter = {};
            // authentication AccessToken required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey('X-Webitel-Access')
                    : await configuration.apiKey;
                localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json';
            localVarUrlObj.query = {
                ...localVarUrlObj.query,
                ...localVarQueryParameter,
                ...options.query,
            };
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {
                ...localVarHeaderParameter,
                ...headersFromBaseOptions,
                ...options.headers,
            };
            const needsSerialization = typeof body !== 'string' ||
                localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data = needsSerialization
                ? JSON.stringify(body !== undefined ? body : {})
                : body || '';
            return {
                url: globalImportUrl.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         *
         * @summary DeleteQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteQueueResourceGroup: async (queueId, id, domainId, options = {}) => {
            // verify required parameter 'queueId' is not null or undefined
            if (queueId === null || queueId === undefined) {
                throw new RequiredError('queueId', 'Required parameter queueId was null or undefined when calling deleteQueueResourceGroup.');
            }
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id', 'Required parameter id was null or undefined when calling deleteQueueResourceGroup.');
            }
            const localVarPath = `/call_center/queues/{queue_id}/resource_groups/{id}`
                .replace(`{${'queue_id'}}`, encodeURIComponent(String(queueId)))
                .replace(`{${'id'}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = globalImportUrl.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = {
                method: 'DELETE',
                ...baseOptions,
                ...options,
            };
            const localVarHeaderParameter = {};
            const localVarQueryParameter = {};
            // authentication AccessToken required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey('X-Webitel-Access')
                    : await configuration.apiKey;
                localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
            }
            if (domainId !== undefined) {
                localVarQueryParameter['domain_id'] = domainId;
            }
            localVarUrlObj.query = {
                ...localVarUrlObj.query,
                ...localVarQueryParameter,
                ...options.query,
            };
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {
                ...localVarHeaderParameter,
                ...headersFromBaseOptions,
                ...options.headers,
            };
            return {
                url: globalImportUrl.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         *
         * @summary ReadQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readQueueResourceGroup: async (queueId, id, domainId, options = {}) => {
            // verify required parameter 'queueId' is not null or undefined
            if (queueId === null || queueId === undefined) {
                throw new RequiredError('queueId', 'Required parameter queueId was null or undefined when calling readQueueResourceGroup.');
            }
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id', 'Required parameter id was null or undefined when calling readQueueResourceGroup.');
            }
            const localVarPath = `/call_center/queues/{queue_id}/resource_groups/{id}`
                .replace(`{${'queue_id'}}`, encodeURIComponent(String(queueId)))
                .replace(`{${'id'}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = globalImportUrl.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = {
                method: 'GET',
                ...baseOptions,
                ...options,
            };
            const localVarHeaderParameter = {};
            const localVarQueryParameter = {};
            // authentication AccessToken required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey('X-Webitel-Access')
                    : await configuration.apiKey;
                localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
            }
            if (domainId !== undefined) {
                localVarQueryParameter['domain_id'] = domainId;
            }
            localVarUrlObj.query = {
                ...localVarUrlObj.query,
                ...localVarQueryParameter,
                ...options.query,
            };
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {
                ...localVarHeaderParameter,
                ...headersFromBaseOptions,
                ...options.headers,
            };
            return {
                url: globalImportUrl.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         *
         * @summary SearchQueueResourceGroup
         * @param {string} queueId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<number>} [id]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchQueueResourceGroup: async (queueId, page, size, q, sort, fields, id, options = {}) => {
            // verify required parameter 'queueId' is not null or undefined
            if (queueId === null || queueId === undefined) {
                throw new RequiredError('queueId', 'Required parameter queueId was null or undefined when calling searchQueueResourceGroup.');
            }
            const localVarPath = `/call_center/queues/{queue_id}/resource_groups`.replace(`{${'queue_id'}}`, encodeURIComponent(String(queueId)));
            const localVarUrlObj = globalImportUrl.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = {
                method: 'GET',
                ...baseOptions,
                ...options,
            };
            const localVarHeaderParameter = {};
            const localVarQueryParameter = {};
            // authentication AccessToken required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey('X-Webitel-Access')
                    : await configuration.apiKey;
                localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
            }
            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (q !== undefined) {
                localVarQueryParameter['q'] = q;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (fields) {
                localVarQueryParameter['fields'] = fields;
            }
            if (id) {
                localVarQueryParameter['id'] = id;
            }
            localVarUrlObj.query = {
                ...localVarUrlObj.query,
                ...localVarQueryParameter,
                ...options.query,
            };
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {
                ...localVarHeaderParameter,
                ...headersFromBaseOptions,
                ...options.headers,
            };
            return {
                url: globalImportUrl.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         *
         * @summary UpdateQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {EngineUpdateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateQueueResourceGroup: async (queueId, id, body, options = {}) => {
            // verify required parameter 'queueId' is not null or undefined
            if (queueId === null || queueId === undefined) {
                throw new RequiredError('queueId', 'Required parameter queueId was null or undefined when calling updateQueueResourceGroup.');
            }
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id', 'Required parameter id was null or undefined when calling updateQueueResourceGroup.');
            }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling updateQueueResourceGroup.');
            }
            const localVarPath = `/call_center/queues/{queue_id}/resource_groups/{id}`
                .replace(`{${'queue_id'}}`, encodeURIComponent(String(queueId)))
                .replace(`{${'id'}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = globalImportUrl.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = {
                method: 'PUT',
                ...baseOptions,
                ...options,
            };
            const localVarHeaderParameter = {};
            const localVarQueryParameter = {};
            // authentication AccessToken required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey('X-Webitel-Access')
                    : await configuration.apiKey;
                localVarHeaderParameter['X-Webitel-Access'] = localVarApiKeyValue;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json';
            localVarUrlObj.query = {
                ...localVarUrlObj.query,
                ...localVarQueryParameter,
                ...options.query,
            };
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {
                ...localVarHeaderParameter,
                ...headersFromBaseOptions,
                ...options.headers,
            };
            const needsSerialization = typeof body !== 'string' ||
                localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data = needsSerialization
                ? JSON.stringify(body !== undefined ? body : {})
                : body || '';
            return {
                url: globalImportUrl.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    };
};
/**
 * QueueResourcesServiceApi - functional programming interface
 * @export
 */
export const QueueResourcesServiceApiFp = function (configuration) {
    return {
        /**
         *
         * @summary CreateQueueResourceGroup
         * @param {string} queueId
         * @param {EngineCreateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createQueueResourceGroup(queueId, body, options) {
            const localVarAxiosArgs = await QueueResourcesServiceApiAxiosParamCreator(configuration).createQueueResourceGroup(queueId, body, options);
            return (axios = globalAxios, basePath = BASE_PATH) => {
                const axiosRequestArgs = {
                    ...localVarAxiosArgs.options,
                    url: basePath + localVarAxiosArgs.url,
                };
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         *
         * @summary DeleteQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteQueueResourceGroup(queueId, id, domainId, options) {
            const localVarAxiosArgs = await QueueResourcesServiceApiAxiosParamCreator(configuration).deleteQueueResourceGroup(queueId, id, domainId, options);
            return (axios = globalAxios, basePath = BASE_PATH) => {
                const axiosRequestArgs = {
                    ...localVarAxiosArgs.options,
                    url: basePath + localVarAxiosArgs.url,
                };
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         *
         * @summary ReadQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async readQueueResourceGroup(queueId, id, domainId, options) {
            const localVarAxiosArgs = await QueueResourcesServiceApiAxiosParamCreator(configuration).readQueueResourceGroup(queueId, id, domainId, options);
            return (axios = globalAxios, basePath = BASE_PATH) => {
                const axiosRequestArgs = {
                    ...localVarAxiosArgs.options,
                    url: basePath + localVarAxiosArgs.url,
                };
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         *
         * @summary SearchQueueResourceGroup
         * @param {string} queueId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<number>} [id]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options) {
            const localVarAxiosArgs = await QueueResourcesServiceApiAxiosParamCreator(configuration).searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options);
            return (axios = globalAxios, basePath = BASE_PATH) => {
                const axiosRequestArgs = {
                    ...localVarAxiosArgs.options,
                    url: basePath + localVarAxiosArgs.url,
                };
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         *
         * @summary UpdateQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {EngineUpdateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateQueueResourceGroup(queueId, id, body, options) {
            const localVarAxiosArgs = await QueueResourcesServiceApiAxiosParamCreator(configuration).updateQueueResourceGroup(queueId, id, body, options);
            return (axios = globalAxios, basePath = BASE_PATH) => {
                const axiosRequestArgs = {
                    ...localVarAxiosArgs.options,
                    url: basePath + localVarAxiosArgs.url,
                };
                return axios.request(axiosRequestArgs);
            };
        },
    };
};
/**
 * QueueResourcesServiceApi - factory interface
 * @export
 */
export const QueueResourcesServiceApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @summary CreateQueueResourceGroup
         * @param {string} queueId
         * @param {EngineCreateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createQueueResourceGroup(queueId, body, options) {
            return QueueResourcesServiceApiFp(configuration)
                .createQueueResourceGroup(queueId, body, options)
                .then((request) => request(axios, basePath));
        },
        /**
         *
         * @summary DeleteQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteQueueResourceGroup(queueId, id, domainId, options) {
            return QueueResourcesServiceApiFp(configuration)
                .deleteQueueResourceGroup(queueId, id, domainId, options)
                .then((request) => request(axios, basePath));
        },
        /**
         *
         * @summary ReadQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {string} [domainId]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readQueueResourceGroup(queueId, id, domainId, options) {
            return QueueResourcesServiceApiFp(configuration)
                .readQueueResourceGroup(queueId, id, domainId, options)
                .then((request) => request(axios, basePath));
        },
        /**
         *
         * @summary SearchQueueResourceGroup
         * @param {string} queueId
         * @param {number} [page]
         * @param {number} [size]
         * @param {string} [q]
         * @param {string} [sort]
         * @param {Array<string>} [fields]
         * @param {Array<number>} [id]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options) {
            return QueueResourcesServiceApiFp(configuration)
                .searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options)
                .then((request) => request(axios, basePath));
        },
        /**
         *
         * @summary UpdateQueueResourceGroup
         * @param {string} queueId
         * @param {string} id
         * @param {EngineUpdateQueueResourceGroupRequest} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateQueueResourceGroup(queueId, id, body, options) {
            return QueueResourcesServiceApiFp(configuration)
                .updateQueueResourceGroup(queueId, id, body, options)
                .then((request) => request(axios, basePath));
        },
    };
};
/**
 * QueueResourcesServiceApi - object-oriented interface
 * @export
 * @class QueueResourcesServiceApi
 * @extends {BaseAPI}
 */
export class QueueResourcesServiceApi extends BaseAPI {
    /**
     *
     * @summary CreateQueueResourceGroup
     * @param {string} queueId
     * @param {EngineCreateQueueResourceGroupRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QueueResourcesServiceApi
     */
    createQueueResourceGroup(queueId, body, options) {
        return QueueResourcesServiceApiFp(this.configuration)
            .createQueueResourceGroup(queueId, body, options)
            .then((request) => request(this.axios, this.basePath));
    }
    /**
     *
     * @summary DeleteQueueResourceGroup
     * @param {string} queueId
     * @param {string} id
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QueueResourcesServiceApi
     */
    deleteQueueResourceGroup(queueId, id, domainId, options) {
        return QueueResourcesServiceApiFp(this.configuration)
            .deleteQueueResourceGroup(queueId, id, domainId, options)
            .then((request) => request(this.axios, this.basePath));
    }
    /**
     *
     * @summary ReadQueueResourceGroup
     * @param {string} queueId
     * @param {string} id
     * @param {string} [domainId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QueueResourcesServiceApi
     */
    readQueueResourceGroup(queueId, id, domainId, options) {
        return QueueResourcesServiceApiFp(this.configuration)
            .readQueueResourceGroup(queueId, id, domainId, options)
            .then((request) => request(this.axios, this.basePath));
    }
    /**
     *
     * @summary SearchQueueResourceGroup
     * @param {string} queueId
     * @param {number} [page]
     * @param {number} [size]
     * @param {string} [q]
     * @param {string} [sort]
     * @param {Array<string>} [fields]
     * @param {Array<number>} [id]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QueueResourcesServiceApi
     */
    searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options) {
        return QueueResourcesServiceApiFp(this.configuration)
            .searchQueueResourceGroup(queueId, page, size, q, sort, fields, id, options)
            .then((request) => request(this.axios, this.basePath));
    }
    /**
     *
     * @summary UpdateQueueResourceGroup
     * @param {string} queueId
     * @param {string} id
     * @param {EngineUpdateQueueResourceGroupRequest} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QueueResourcesServiceApi
     */
    updateQueueResourceGroup(queueId, id, body, options) {
        return QueueResourcesServiceApiFp(this.configuration)
            .updateQueueResourceGroup(queueId, id, body, options)
            .then((request) => request(this.axios, this.basePath));
    }
}
//# sourceMappingURL=queue-resources-service-api.js.map