import { __awaiter, __extends, __generator } from "tslib";
import qs from 'query-string';
import BaseGetterApiConsumer from '../base-getter-api-consumer/base-getter-api-consumer';
var EndpointGetterApiConsumer = /** @class */ (function (_super) {
    __extends(EndpointGetterApiConsumer, _super);
    function EndpointGetterApiConsumer(_a, params) {
        var baseUrl = _a.baseUrl, instance = _a.instance;
        if (params === void 0) { params = {}; }
        var _this = _super.call(this, params) || this;
        _this.instance = instance;
        _this.baseUrl = baseUrl;
        if (params.nestedUrl)
            _this.nestedUrl = params.nestedUrl;
        return _this;
    }
    EndpointGetterApiConsumer.prototype.getItem = function (params) {
        return this._getItem(params);
    };
    EndpointGetterApiConsumer.prototype.getNestedItem = function (_a) {
        var parentId = _a.parentId, itemId = _a.itemId, query = _a.query;
        var baseUrl = this.baseUrl + "/" + parentId + "/" + this.nestedUrl;
        return this._getItem({ itemId: itemId, query: query }, baseUrl);
    };
    EndpointGetterApiConsumer.prototype._getItem = function (_a, baseUrl) {
        var itemId = _a.itemId, query = _a.query;
        if (baseUrl === void 0) { baseUrl = this.baseUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var url, response, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = baseUrl + "/" + itemId;
                        if (query) {
                            url += "?" + qs.stringify(query, {
                                skipEmptyString: true,
                                skipNull: true,
                            });
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.instance.get(url)];
                    case 2:
                        response = _b.sent();
                        response = this.responseHandler(response);
                        if (this.userResponseHandler) {
                            response = this.userResponseHandler(response);
                        }
                        return [2 /*return*/, response];
                    case 3:
                        err_1 = _b.sent();
                        throw err_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return EndpointGetterApiConsumer;
}(BaseGetterApiConsumer));
export default EndpointGetterApiConsumer;
//# sourceMappingURL=endpoint-getter-api-consumer.js.map