import { __awaiter, __extends, __generator } from "tslib";
import dcopy from 'deep-copy';
import sanitizer from '../../_shared/utils/sanitizer';
import BasePatcherApiConsumer from '../base-patcher-api-consumer/base-patcher-api-consumer';
var EndpointPatcherApiConsumer = /** @class */ (function (_super) {
    __extends(EndpointPatcherApiConsumer, _super);
    function EndpointPatcherApiConsumer(_a, params) {
        var baseUrl = _a.baseUrl, instance = _a.instance;
        if (params === void 0) { params = {}; }
        var _this = _super.call(this, params) || this;
        _this.instance = instance;
        _this.baseUrl = baseUrl;
        if (params.nestedUrl)
            _this.nestedUrl = params.nestedUrl;
        return _this;
    }
    EndpointPatcherApiConsumer.prototype.patchItem = function (_a, afterUrl) {
        var id = _a.id, changes = _a.changes;
        var updUrl = this.baseUrl + "/" + id;
        if (afterUrl)
            updUrl += "/" + afterUrl;
        var changesCopy = dcopy(changes);
        if (this.preRequestHandler) {
            changesCopy = this.preRequestHandler(changesCopy);
        }
        if (this.fieldsToSend) {
            changesCopy = sanitizer(changesCopy, this.fieldsToSend);
        }
        return this._patchItem(changesCopy, updUrl);
    };
    EndpointPatcherApiConsumer.prototype.patchNestedItem = function (_a) {
        var parentId = _a.parentId, id = _a.id, changes = _a.changes, afterUrl = _a.afterUrl;
        var updUrl = this.baseUrl + "/" + parentId + "/" + this.nestedUrl + "/" + id;
        if (afterUrl)
            updUrl += "/" + afterUrl;
        var changesCopy = dcopy(changes);
        if (this.preRequestHandler) {
            changesCopy = this.preRequestHandler(changesCopy);
        }
        if (this.fieldsToSend) {
            changesCopy = sanitizer(changesCopy, this.fieldsToSend);
        }
        return this._patchItem(changes, updUrl);
    };
    EndpointPatcherApiConsumer.prototype._patchItem = function (changes, baseUrl) {
        if (baseUrl === void 0) { baseUrl = this.baseUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.instance.patch(baseUrl, changes)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return EndpointPatcherApiConsumer;
}(BasePatcherApiConsumer));
export default EndpointPatcherApiConsumer;
//# sourceMappingURL=endpoint-patcher-api-consumer.js.map