import { __awaiter, __extends, __generator } from "tslib";
import dcopy from 'deep-copy';
import sanitizer from '../../_shared/utils/sanitizer';
import BasePatcherApiConsumer from '../base-patcher-api-consumer/base-patcher-api-consumer';
var SdkPatcherApiConsumer = /** @class */ (function (_super) {
    __extends(SdkPatcherApiConsumer, _super);
    function SdkPatcherApiConsumer(SDKMethod, params) {
        if (params === void 0) { params = {}; }
        var _this = _super.call(this, params) || this;
        _this.SDKMethod = SDKMethod;
        return _this;
    }
    SdkPatcherApiConsumer.prototype.patchItem = function (_a) {
        var id = _a.id, changes = _a.changes;
        var changesCopy = dcopy(changes);
        if (this.preRequestHandler) {
            changesCopy = this.preRequestHandler(changesCopy);
        }
        if (this.fieldsToSend) {
            changesCopy = sanitizer(changesCopy, this.fieldsToSend);
        }
        return this._patchItem([id, changesCopy]);
    };
    SdkPatcherApiConsumer.prototype.patchNestedItem = function (_a) {
        var parentId = _a.parentId, id = _a.id, changes = _a.changes;
        var changesCopy = dcopy(changes);
        if (this.preRequestHandler) {
            changesCopy = this.preRequestHandler(changesCopy, parentId);
        }
        if (this.fieldsToSend) {
            changesCopy = sanitizer(changesCopy, this.fieldsToSend);
        }
        return this._patchItem([parentId, id, changesCopy]);
    };
    SdkPatcherApiConsumer.prototype._patchItem = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.SDKMethod.apply(this, args)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return SdkPatcherApiConsumer;
}(BasePatcherApiConsumer));
export default SdkPatcherApiConsumer;
//# sourceMappingURL=sdk-patcher-api-consumer.js.map