import { __awaiter, __extends, __generator } from "tslib";
import dcopy from 'deep-copy';
import sanitizer from '../../_shared/utils/sanitizer';
import BaseUpdaterApiConsumer from '../base-updater-api-consumer/base-updater-api-consumer';
var SdkUpdaterApiConsumer = /** @class */ (function (_super) {
    __extends(SdkUpdaterApiConsumer, _super);
    function SdkUpdaterApiConsumer(SDKMethod, params) {
        if (params === void 0) { params = {}; }
        var _this = _super.call(this, params) || this;
        _this.SDKMethod = SDKMethod;
        return _this;
    }
    SdkUpdaterApiConsumer.prototype.updateItem = function (_a) {
        var itemId = _a.itemId, itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        return this._updateItem([itemId, itemCopy]);
    };
    SdkUpdaterApiConsumer.prototype.updateNestedItem = function (_a) {
        var parentId = _a.parentId, itemId = _a.itemId, itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy, parentId);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        return this._updateItem([parentId, itemId, itemCopy]);
    };
    SdkUpdaterApiConsumer.prototype._updateItem = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.SDKMethod.apply(this, args)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, this.responseHandler(response)];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return SdkUpdaterApiConsumer;
}(BaseUpdaterApiConsumer));
export default SdkUpdaterApiConsumer;
//# sourceMappingURL=sdk-updater-api-consumer.js.map