const path = require('path');
const fs = require("fs");

const electron = require('electron');
const userDataPath = (electron.app || electron.remote.app).getPath(
    'userData'
);

const CONFIG_FILE = 'config.json';
const STORAGE_FILE = 'storage.json';
const LOGS_FOLDER = 'SipLogs';

let _conf = null;

const DEFAULT_CONFIG = JSON.stringify({
    "URL": "https://webitel-01/workspace/",
    "useSIP": true,
    "timeoutSIP": "90",
    "debugMode": true
})

const config = () => {
    if (_conf)
        return _conf;

    if (!fs.existsSync(path.join(userDataPath, LOGS_FOLDER))){
        fs.mkdirSync(path.join(userDataPath, LOGS_FOLDER));
    }
    const p = configPath();
    console.error('path: ' + p)
    if (fs.existsSync(p)) {
        _conf = require(configPath())
        return _conf;
    } else {
        fs.writeFileSync(p, DEFAULT_CONFIG)
        return DEFAULT_CONFIG
    }
};

const configPath = () => {
    return path.join(userDataPath, CONFIG_FILE)
}

const storagePath = () => {
    return path.join(userDataPath, STORAGE_FILE)
}

module.exports = {
    config,
    configPath,
    storagePath,
}